package graphismes.externes;

import graphismes.internes.Menu;
import graphismes.internes.PanneauDeFond;

import javax.swing.*;
import java.awt.*;
import java.io.BufferedReader;
import java.io.FileReader;

public class Fenetre {

    private static JFrame fenetre = null;
    private static final String CHEMINFIHIERCONFIGURATION = "./configuration/configuration.txt";

    private Fenetre(){}

    public static JFrame getFenetre(){
        if(fenetre == null)
            init();
        return fenetre;
    }

    private static void init(){
        fenetre = new JFrame();
        fenetre.setUndecorated(true);
        fenetre.setTitle("La fuite de Sualocine");
        fenetre.setSize(lectureConfiguration());
        fenetre.setLocationRelativeTo(null);
        fenetre.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        fenetre.setVisible(true);
    }


    private static Dimension lectureConfiguration(){
        FileReader fichierConfig;
        BufferedReader br;
        String line=null;
        String everything = null;
        try {
            fichierConfig = new FileReader(CHEMINFIHIERCONFIGURATION);
            br = new BufferedReader(fichierConfig);
            StringBuilder sb = new StringBuilder();
            line = br.readLine();

            while (line != null) {
                sb.append(line);
                line = br.readLine();
            }
            everything = sb.toString();
        } catch(Exception e){
            e.printStackTrace();
            System.out.println("Erreur Fenetre.java incapable de lire le fichier de configuration. \n\tErreur: "+e);
        }

        String[] result = everything.split(" ", 2);
        String largeur = result[0]; String hauteur = result[1];

        int width = Integer.parseInt(largeur);
        int height = Integer.parseInt(hauteur);

        fenetre.setContentPane(new PanneauDeFond());
        fenetre.getContentPane().add(new Menu());

        return new Dimension(width, height);
    }

}
