package personnages;

import graphismes.internes.Tuile;
import graphismes.outils.LecteurImage;
import graphismes.outils.Point;

import java.awt.event.KeyEvent;
import java.awt.image.BufferedImage;

public class Sualocine {

    private String cheminImage = "res/images/sualocine.png";
    private BufferedImage image;
    private boolean enVie = true;
    public Tuile collisionCarre;

    private int x, dx, y, dy, vie;
    private final int HAUTEUR = 75, LARGEUR = 65, YMAX = 750, VIEMAX=100, VIEMIN=0, HAUTEURINIT = 550;

    public Sualocine(){
        init();
    }

    private void init(){
        image = LecteurImage.donneImage(cheminImage);
        vie = VIEMAX;
        x=150;
        y=HAUTEURINIT;
        collisionCarre = new Tuile(new Point(x,y), LARGEUR, HAUTEUR);
        collisionCarre.setType(1);
    }

    public void move(){
        x += dx;
        y += dy;

        collisionCarre.getHautGauche().controleVertical(dx);
    }

    public boolean meurt(){ return (vie<=VIEMIN || y<YMAX); }

    public BufferedImage getImage(){return image;}
    public int getX(){return x;}
    public int getY(){return y;}
    public int getDY(){return dy;}
    public int getHAUTEUR(){return HAUTEUR;}
    public int getLARGEUR(){return LARGEUR;}
    public Point getHautGauche(){return collisionCarre.getHautGauche();}
    public Point getHautDroite(){return collisionCarre.getHautDroite();}
    public Point getBasGauche(){return collisionCarre.getBasGauche();}
    public Point getBasDroite(){return collisionCarre.getBasDroite();}


    public boolean estVivante(){
        enVie = meurt();
        return enVie;
    }

    public void keyPressed(KeyEvent e) {
        int touche = e.getKeyCode();

        if(touche == KeyEvent.VK_Q){ //on va à gauche.
            dx = -1;
        }
        if(touche == KeyEvent.VK_D){ //on va à droite.
            dx = 1;
        }
        if(touche == KeyEvent.VK_Z){ //on monte.
            dy = 1;
        }
    }

    public void keyReleased(KeyEvent e) {
        int touche = e.getKeyCode();

        if(touche == KeyEvent.VK_Q || touche == KeyEvent.VK_D){ //on arrête de bouger horizontalement.
            dx = 0;
        }
        if(touche == KeyEvent.VK_Z || touche == KeyEvent.VK_S){ //on arrête de bouger verticalement.
            dy = 0;
        }
    }

}
